/* Generated automatically by the program 'build/genpreds'
   from the machine description file '../../gcc-4.6.4/gcc/config/msp430/msp430.md'.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "tree.h"
#include "tm_p.h"
#include "function.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "hard-reg-set.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"

int
msp430_rmw_operator (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case AND:
    case IOR:
    case XOR:
    case PLUS:
    case MINUS:
      break;
    default:
      return false;
    }
  return 
(mode == VOIDmode || GET_MODE (op) == mode);
}

int
msp430_post_inc_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return ((GET_CODE (op) == MEM) && ((GET_CODE (XEXP (op, 0)) == POST_INC) && (GET_CODE (XEXP (XEXP (op, 0), 0)) == REG))) && (
(mode == VOIDmode || GET_MODE (op) == mode));
}

int
msp430_source_operand (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  return (general_operand (op, mode)) || (msp430_post_inc_operand (op, mode));
}

int
equality_operator (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  switch (GET_CODE (op))
    {
    case EQ:
    case NE:
      return true;
    default:
      break;
    }
  return false;
}

enum constraint_num
lookup_constraint (const char *str)
{
  switch (str[0])
    {
    case 'M':
      return CONSTRAINT_M;
    case 'N':
      return CONSTRAINT_N;
    case 'P':
      return CONSTRAINT_P;
    case 'Q':
      return CONSTRAINT_Q;
    case 'R':
      return CONSTRAINT_R;
    case 'S':
      return CONSTRAINT_S;
    case 'T':
      return CONSTRAINT_T;
    case 'U':
      return CONSTRAINT_U;
    case 'W':
      return CONSTRAINT_W;
    case 'Y':
      return CONSTRAINT_Y;
    case 'u':
      return CONSTRAINT_u;
    case 'w':
      return CONSTRAINT_w;
    case 'y':
      return CONSTRAINT_y;
    case 'z':
      return CONSTRAINT_z;
    default: break;
    }
  return CONSTRAINT__UNKNOWN;
}

enum reg_class
regclass_for_constraint (enum constraint_num c)
{
  switch (c)
    {
    case CONSTRAINT_z: return PC_REG;
    case CONSTRAINT_y: return SP_REG;
    case CONSTRAINT_Y: return GENERAL_SP_REGS;
    case CONSTRAINT_w: return SR_REG;
    case CONSTRAINT_W: return GENERAL_SR_REGS;
    case CONSTRAINT_u: return FIXED_PSEUDO_REGS;
    case CONSTRAINT_U: return FIXED_PSEUDO_GENERAL_SP_REGS;
    default: break;
    }
  return NO_REGS;
}

bool
constraint_satisfied_p (rtx op, enum constraint_num c)
{
  switch (c)
    {
    case CONSTRAINT_R: return satisfies_constraint_R (op);
    case CONSTRAINT_S: return satisfies_constraint_S (op);
    case CONSTRAINT_T: return satisfies_constraint_T (op);
    case CONSTRAINT_M: return satisfies_constraint_M (op);
    case CONSTRAINT_Q: return satisfies_constraint_Q (op);
    case CONSTRAINT_N: return satisfies_constraint_N (op);
    case CONSTRAINT_P: return satisfies_constraint_P (op);
    default: break;
    }
  return false;
}

bool
insn_const_int_ok_for_constraint (HOST_WIDE_INT ival, enum constraint_num c)
{
  switch (c)
    {
    case CONSTRAINT_M:
      return 
#line 64 "../../gcc-4.6.4/gcc/config/msp430/constraints.md"
(msp430_cpu & MSP430_CPU_MSP430X && MSP430_CPUX_MULTISHIFT_COUNT_P(ival));

    case CONSTRAINT_N:
      return 
#line 75 "../../gcc-4.6.4/gcc/config/msp430/constraints.md"
((MSP430_MIN_GENERAL_REGNUM <= ival) && (ival <= MSP430_MAX_GENERAL_REGNUM));

    case CONSTRAINT_P:
      return 
#line 80 "../../gcc-4.6.4/gcc/config/msp430/constraints.md"
((ival == -1 || ival == 0 || ival == 1 || ival == 2 || ival == 4 || ival == 8));

    default: break;
    }
  return false;
}

